Unit iam1e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure iam1e(N :Integer; X0 :Extended; var X :Array of Extended;
                var Y :Array of Extended; var Z :Array of Extended;
                var II :Array of Integer; var F0 :Array of Extended);

implementation

procedure iam1e(N :Integer; X0 :Extended; var X :Array of Extended;
                var Y :Array of Extended; var Z :Array of Extended;
                var II :Array of Integer; var F0 :Array of Extended);
var
I,I0,I1,I2,J,NN,NN1 :Integer;
R,R1,R2 :Extended;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130;
begin
F0[0] := Y[0]*(X[0] - X0);
for I:=2 to N do
 begin
  F0[I-1] := F0[I-2] + Y[I-1]*(X[I-1] - X[I-2]);
_10:
 end;
II[0] := 1;
NN  := 1;
_20:
if ( II[NN-1] =  N ) 
 then goto _70;
II[NN+0] := II[NN-1] + 1;
NN  := NN + 1;
_30:
if ( NN - 2 ) < 0
 then goto _20
 else if ( NN - 2 ) > 0
       then goto _50
       else goto _40;
_40:
I1  := II[0];
I2  := II[1];
if ( F0[I2-1]*(X[I1-1] - X0) - F0[I1-1]*(X[I2-1] - X0) ) < 0
 then goto _60
 else if ( F0[I2-1]*(X[I1-1] - X0) - F0[I1-1]*(X[I2-1] - X0) ) > 0
       then goto _20
       else goto _20;
_50:
I0  := II[NN-3];
I1  := II[NN-2];
I2  := II[NN-1];
R1  := (F0[I2-1] - F0[I1-1])*(X[I1-1] - X[I0-1]);
R2  := (X[I2-1] - X[I1-1])*(F0[I1-1] - F0[I0-1]);
if ( R1  >=  R2 ) 
 then goto _20;
_60:
II[NN-2] := II[NN-1];
NN  := NN - 1;
goto _20;
_70:
if ( NN  =  1 ) 
 then goto _100;
for J:=2 to NN do
 begin
  I1  := II[J-2];
  I2  := II[J-1];
  R  := (F0[I2-1] - F0[I1-1])/(X[I2-1] - X[I1-1]);
  I1  := I1 + 1;
  for I:=I1 to I2 do
   begin
    Z[I-1] := R;
_80:
   end;
_90:
 end;
_100:
I1  := II[0];
R  := F0[I1-1]/(X[I1-1] - X0);
for I:=1 to I1 do
 begin
  Z[I-1] := R;
_110:
 end;
if ( NN  =  N ) 
 then goto _130;
NN1  := NN + 1;
for I:=NN1 to N do
 begin
  II[I-1] := 0;
_120:
 end;
_130:
end;

end.
